package slothLib.NLP;

/// <summary>
/// 形態素の表層形（出現形）のみを残すフィルタ
/// </summary>
public class RemainRawFilter extends AbstractMorphemeToStringFilter
{
	/// <summary>
	/// 表層形（出現形）のみを残す
	/// </summary>
	/// <param name="morpheme">フィルタを適用する形態素</param>
	/// <returns>フィルタ適用語の文字列</returns>
	public String doFilter(IMorpheme morpheme)
	{
		return morpheme.getRaw();
	}
}

